%
% Examples of how to access data in octav/matlab
% Run this script by typing 
% source('octave_hdf5.m')
% in octave
%
1;
%
% Load the file
%
fin='../data.h5';

%
% Local copy of the pedestals
%
pedestal = h5read(fin, '/header/pedestal');
noise    = h5read(fin,'/header/noise');


%
% Compute pedestals from all data
%
S = h5read(fin,'/events/signal'); % The signal array
T = h5read(fin,'/events/time'); 
P = mean(S,2);     % The computed pedestals

%
% Play with one event data
%
[nchan, nevts] = size(S);
nchip    = nchan/128;

ievt = 1;
[ss, sn, cm] = process_event(ievt, S, pedestal, noise);

% find strips with signal/noise > 5
channels = find( sn>5.0 );
the_signal = ss( channels );

%
% Now process the whole file
%
% Get the events with good timing
GT = find( T > 12.0 );

% Reduce the data sample to those events
St=S(:, GT);

% ... and process
G = process_dataset(St, pedestal, noise);
X = 1:5:500;
hist(G,X);
