%
% Examples of how to access data in octav/matlab
% Run this script by typing 
% source('octave_hdf5.m')
% in octave
%
1;
%
% Load the file
%
load ../../data.h5;

%
% Local copy of the pedestals
%
pedestal = header.pedestal;
noise    = header.noise;


%
% Compute pedestals from all data
%
S = events.signal; % The signal array
P = mean(S,2);     % The computed pedestals

%
% Play with one event data
%
[nchan, nevts] = size(S);
nchip    = nchan/128;

ievt = 1;
[ss, sn, cm] = process_event(ievt, S, pedestal, noise);

% find strips with signal/noise > 5
channels = find( sn>5.0 );
the_signal = ss( channels );

%
% Now process the whole file
%
% Get the events with good timing
GT = find( events.time > 12.0 );

G = zeros(0,1);
for ievt = GT
    [ss, sn, cm] = process_event(ievt, S, pedestal, noise);
    channels = find(sn>5.0);
    sz = size(channels);
    nchan = sz(1);
    if ( nchan==1 ) % We do not know how to make clusters yet...
      for ic = 1:nchan
        G(end+1) = ss( channels(ic) );
      end
    end      
end


% Reduce the data sample to those events
%St=S(:, GT);

% ... and process
%G = process_dataset(St, pedestal, noise);
X = 1:5:500;
hist(G,X);
