/*
 * DataFile.cc
 *
 *  Created on: Mar 4, 2014
 *      Author: lacasta
 */
#include <glib.h>
#ifdef HAVE_CONFIG_H
#ifdef G_OS_WIN32
#include "config_win.h"
#else
#include <config.h>
#endif
#endif
#include "DataFile.h"
#include "AsciiDataFile.h"
#include "HDFDataFile.h"

DataFile *DataFile::factory(FileType type, const std::string fnam)
{
    DataFile *out = 0;
    switch (type)
    {
        case AsciiFile:
            out = new AsciiDataFile(fnam);
            break;
#ifdef HAVE_HDF5
        case HDF5:
            out = new HDFDataFile(fnam);
            break;
#endif
        default:
            break;
    }
    return out;
}

