/* -*- mode: c++ -*- */
#ifndef __TriggerConfig_h__
#define __TriggerConfig_h__

#include <ConfigFile.h>

class TriggerConfig : public ConfigFile
{
    private:
        bool _and;
        bool _pulse;
        int _dacA;
        int _dacB;
        int _dacC;
        int _dacD;

        void cpy(const TriggerConfig &);
    public:
        TriggerConfig();
        virtual ~TriggerConfig();
        TriggerConfig(const TriggerConfig &t)
        {
            cpy(t);
        }
        TriggerConfig &operator=(const TriggerConfig &t)
        {
            if (this!=&t)
                cpy(t);

            return *this;
        }

        bool trigger_and() const
        {
            return _and;
        }
        void trigger_and(bool x)
        {
            _and=x;
        }

        bool pulse() const
        {
            return _pulse;
        }
        void pulse(bool x)
        {
            _pulse = x;
        }

        int dacA() const
        {
            return _dacA;
        }
        void dacA(int x)
        {
            _dacA = x;
        }

        int dacB() const
        {
            return _dacB;
        }
        void dacB(int x)
        {
            _dacB = x;
        }

        int dacC() const
        {
            return _dacC;
        }
        void dacC(int x)
        {
            _dacC = x;
        }

        int dacD() const
        {
            return _dacD;
        }
        void dacD(int x)
        {
            _dacD = x;
        }

        void load_data();
        void save_data();

};

#endif
