/* -*- mode: c++ -*- */
#ifndef __ALIBAVA_SERVER_H__
#define __ALIBAVA_SERVER_H__

#include <sys/ioctl.h>
#include <glib.h>


#ifdef ALIBAVA_SERVER
#ifndef ASCII
#define ASCII 1
#include <utils.h>
#undef ASCII
#else
#include <utils.h>
#endif
#else
#include <utils.h>

#endif

/*
 * The commands. This are defined like ioctls
 *
 */
#define ALIBAVA_IOC_MAGIC  'P'

#define RESET_NR      0
#define DIE_NR        1
#define ERROR_NR      2
#define DO_READ_NR    3
#define ALIBAVA_MAX_COMMAND 3

#define RESET          _IO(ALIBAVA_IOC_MAGIC, RESET_NR)
#define DIE            _IO(ALIBAVA_IOC_MAGIC, DIE_NR)
#define ERROR          _IO(ALIBAVA_IOC_MAGIC, ERROR_NR)
#define DO_READ        _IOW(ALIBAVA_IOC_MAGIC, DO_READ_NR, size_t)

struct client_info
{
        uid_t uid;
        int cfd;
        int fd;
        int sem;
        int command;
        int size;
        GIOChannel *control;
        GIOChannel *io;

        GMutex *mux;
};

#ifndef _IOC_DIR
/* used to decode ioctl numbers.. */
#define _IOC_DIR(nr)        (((nr) >> _IOC_DIRSHIFT) & _IOC_DIRMASK)
#define _IOC_TYPE(nr)       (((nr) >> _IOC_TYPESHIFT) & _IOC_TYPEMASK)
#define _IOC_NR(nr)     (((nr) >> _IOC_NRSHIFT) & _IOC_NRMASK)
#define _IOC_SIZE(nr)       (((nr) >> _IOC_SIZESHIFT) & _IOC_SIZEMASK)

#endif

#define SOCKET_NAME "/tmp/alibava.socket"
#define DAEMON_NAME "alibavad"
//#define DAEMON_PATH "/home/lacasta/workspace/alibava"

#ifndef ALIBAVA_SERVER
int do_open(const char *path, int flags);
int do_close(int fd);
int do_ioctl(int d, int req, ...);
int do_read(int d, void *, size_t);
int do_write(int d, void *, size_t);
void read_event(int fd);
#endif

#endif
