/*
 * mingw.h
 *
 *  Created on: 20/11/2011
 *      Author: Carlos
 */

#ifndef _ALIBAVA_MINGW_H_
#define _ALIBAVA_MINGW_H_

#include <glib.h>
#ifdef G_OS_WIN32
#include <windows.h>
#include <winsock.h>

#define POLLIN      0x0001    /* There is data to read */
#define POLLPRI     0x0002    /* There is urgent data to read */
#define POLLOUT     0x0004    /* Writing now will not block */
#define POLLERR     0x0008    /* Error condition */
#define POLLHUP     0x0010    /* Hung up */
#define POLLNVAL    0x0020    /* Invalid request: fd not open */
struct pollfd {
    SOCKET fd;        /* file descriptor */
    short events;     /* requested events */
    short revents;    /* returned events */
};
//#define poll(x, y, z)        mingw_poll(x, y, z)
int poll(struct pollfd *fds, unsigned int nfds, int timo);
gchar *get_registry_key(const gchar *path, const gchar *key);
gchar *normalize_path(const gchar *path);


//#define RTLD_LAZY 1 /* lazy function call binding */
//#define RTLD_NOW 2 /* immediate function call binding */
//#define RTLD_GLOBAL 4 /* symbols in this dlopen'ed obj are visible
// 			 to other dlopen'ed objs */
//void *dlopen (const char *file, int mode);
//int dlclose (void *handle);
//void *dlsym (void *handle, const char *name);
//char *dlerror (void);

#endif

#endif /* MINGW_H_ */
